package jalview.ws2;

import java.io.IOException;
import java.util.List;

import jalview.api.AlignViewportI;
import jalview.datamodel.AlignmentI;
import jalview.datamodel.SequenceI;

/**
 * A generic function which supplies job result from the remote job to the
 * worker object when the job is finished. Typically, the interface is
 * implemented by one of the {@link WebServiceI} object methods and passed to
 * the {@link WebServiceWorkerI} object on its creation.
 * 
 * @author mmwarowny
 *
 * @param <T>
 *          result type
 */
@FunctionalInterface
public interface ResultSupplier<T>
{
  public T getResult(WSJob job, List<SequenceI> dataset, AlignViewportI viewport) throws IOException;
}
